#include "main.h"

using namespace std;

myarray::myarray(size_t n):n(n){arr=
#ifdef UNIQUE
        std::make_unique<int[]>(n);
#else
        new int[n];
#endif
}
myarray::myarray(myarray&& other)noexcept: arr(
        #ifdef UNIQUE
        std::move(other.arr)
        #else
        other.arr
        #endif
        ),n(other.n){other.arr=0x0;other.n=0;}
int& myarray::operator[] (const size_t index){return arr
#ifdef UNIQUE
        .get()
#endif
        [index];}
void myarray::pow2(){for (int i=0;i<n;i++)arr
#ifdef UNIQUE
            .get()
#endif
                [i]*=arr
#ifdef UNIQUE
                .get()
#endif
                       [i];}
void pow2(myarray &powme){for (int i=0;i<powme.n;i++)powme.arr
#ifdef UNIQUE
            .get()
#endif
                [i]*=powme.arr
#ifdef UNIQUE
                   .get()
#endif
                       [i];};
void pow2(myarray *powme){for (int i=0;i<powme->n;i++)powme->arr
#ifdef UNIQUE
            .get()
#endif
                [i]*=powme->arr
#ifdef UNIQUE
                   .get()
#endif
                       [i];};
size_t myarray::size()const{return n;}
TEST(myarray, constructingSettingAndGetting){
    myarray test(2);
    test[0]=1;
    test[1]=2;
    EXPECT_EQ(test.size(),2);
    ASSERT_EQ(test[0],1);
    EXPECT_EQ(test[1],2);
}
TEST(myarray, powing){
    myarray test(3);test[0]=1;test[1]=2;test[2]=3;
    pow2(test);
    ASSERT_EQ(test[0],1);
    ASSERT_EQ(test[1],4);
    ASSERT_EQ(test[2],9);
    test.pow2();
    ASSERT_EQ(test[0],1);
    ASSERT_EQ(test[1],16);
    ASSERT_EQ(test[2],81);
    pow2(&test);
    ASSERT_EQ(test[0],1);
    ASSERT_EQ(test[1],256);
    ASSERT_EQ(test[2],6561);
}
TEST(myarray, moving){
    myarray test(2);test[0]=1;test[1]=2;
    myarray movehere(std::move(test));
    EXPECT_EQ(test.size(),0);
    EXPECT_EQ(movehere[0],1);
    EXPECT_EQ(movehere[1],2);
}
#ifndef UNIQUE
myarray::~myarray(){delete arr;}
#endif
int main()
{
    testing::InitGoogleTest();
    return RUN_ALL_TESTS();
}
